Index: ntoskrnl/ex/handle.c
===================================================================
--- ntoskrnl/ex/handle.c	(revision 21808)
+++ ntoskrnl/ex/handle.c	(working copy)
@@ -18,6 +18,11 @@
 
 /* INCLUDES *****************************************************************/
 
+//
+// Uses Win2K semantics
+//
+#define NTDDI_VERSION 0x50000000
+
 #include <ntoskrnl.h>
 
 #define NDEBUG
@@ -206,10 +211,10 @@
               curee != laste;
               curee++)
           {
-            if(curee->u1.Object != NULL && SweepHandleCallback != NULL)
+            if(curee->Object != NULL && SweepHandleCallback != NULL)
             {
-              curee->u1.ObAttributes |= EX_HANDLE_ENTRY_LOCKED;
-              SweepHandleCallback(HandleTable, curee->u1.Object, curee->u2.GrantedAccess, Context);
+              curee->ObAttributes |= EX_HANDLE_ENTRY_LOCKED;
+              SweepHandleCallback(HandleTable, curee->Object, curee->GrantedAccess, Context);
             }
           }
         }
@@ -414,7 +419,7 @@
                 srcstbl++, stbl++, eli++)
             {
               /* try to duplicate the source handle */
-              if(srcstbl->u1.Object != NULL &&
+              if(srcstbl->Object != NULL &&
                  ExLockHandleTableEntry(SourceHandleTable,
                                         srcstbl))
               {
@@ -426,15 +431,15 @@
                 {
                   /* free the entry and chain it into the free list */
                   HandleTable->HandleCount--;
-                  stbl->u1.Object = NULL;
-                  stbl->u2.NextFreeTableEntry = HandleTable->FirstFreeTableEntry;
+                  stbl->Object = NULL;
+                  stbl->NextFreeTableEntry = HandleTable->FirstFreeTableEntry;
                   HandleTable->FirstFreeTableEntry = BUILD_HANDLE(tli, mli, eli);
                 }
                 else
                 {
                   /* duplicate the handle and unlock it */
-                  stbl->u2.GrantedAccess = srcstbl->u2.GrantedAccess;
-                  stbl->u1.ObAttributes = srcstbl->u1.ObAttributes & ~EX_HANDLE_ENTRY_LOCKED;
+                  stbl->GrantedAccess = srcstbl->GrantedAccess;
+                  stbl->ObAttributes = srcstbl->ObAttributes & ~EX_HANDLE_ENTRY_LOCKED;
                 }
                 ExUnlockHandleTableEntry(SourceHandleTable,
                                          srcstbl);
@@ -492,9 +497,9 @@
       *Handle = EX_HANDLE_TO_HANDLE(HandleTable->FirstFreeTableEntry);
 
       /* save the index to the next free handle (if available) */
-      HandleTable->FirstFreeTableEntry = Entry->u2.NextFreeTableEntry;
-      Entry->u2.NextFreeTableEntry = 0;
-      Entry->u1.Object = NULL;
+      HandleTable->FirstFreeTableEntry = Entry->NextFreeTableEntry;
+      Entry->NextFreeTableEntry = 0;
+      Entry->Object = NULL;
 
       HandleTable->HandleCount++;
     }
@@ -595,8 +600,8 @@
 
       /* let's just use the very first entry */
       Entry = ntbl;
-      Entry->u1.ObAttributes = EX_HANDLE_ENTRY_LOCKED;
-      Entry->u2.NextFreeTableEntry = 0;
+      Entry->ObAttributes = EX_HANDLE_ENTRY_LOCKED;
+      Entry->NextFreeTableEntry = 0;
 
       *Handle = EX_HANDLE_TO_HANDLE(HandleTable->NextIndexNeedingPool);
 
@@ -609,11 +614,11 @@
           cure != laste;
           cure++, i++)
       {
-        cure->u1.Object = NULL;
-        cure->u2.NextFreeTableEntry = i;
+        cure->Object = NULL;
+        cure->NextFreeTableEntry = i;
       }
       /* truncate the free entry list */
-      (cure - 1)->u2.NextFreeTableEntry = -1;
+      (cure - 1)->NextFreeTableEntry = -1;
 
       /* save the pointers to the allocated list(s) */
       (void)InterlockedExchangePointer(&nmtbl[mli], ntbl);
@@ -651,8 +656,8 @@
   /* automatically unlock the entry if currently locked. We however don't notify
      anyone who waited on the handle because we're holding an exclusive lock after
      all and these locks will fail then */
-  (void)InterlockedExchangePointer(&Entry->u1.Object, NULL);
-  Entry->u2.NextFreeTableEntry = HandleTable->FirstFreeTableEntry;
+  (void)InterlockedExchangePointer(&Entry->Object, NULL);
+  Entry->NextFreeTableEntry = HandleTable->FirstFreeTableEntry;
   HandleTable->FirstFreeTableEntry = Handle;
 
   HandleTable->HandleCount--;
@@ -679,10 +684,10 @@
 
     mlp = HandleTable->Table[tli];
     if(Handle < HandleTable->NextIndexNeedingPool &&
-       mlp != NULL && mlp[mli] != NULL && mlp[mli][eli].u1.Object != NULL)
+       mlp != NULL && mlp[mli] != NULL && mlp[mli][eli].Object != NULL)
     {
       Entry = &mlp[mli][eli];
-      DPRINT("handle lookup 0x%x -> entry 0x%p [HT:0x%p] ptr: 0x%p\n", Handle, Entry, HandleTable, mlp[mli][eli].u1.Object);
+      DPRINT("handle lookup 0x%x -> entry 0x%p [HT:0x%p] ptr: 0x%p\n", Handle, Entry, HandleTable, mlp[mli][eli].Object);
     }
   }
   else
@@ -708,7 +713,7 @@
 
   for(;;)
   {
-    Current = (volatile ULONG_PTR)Entry->u1.Object;
+    Current = (volatile ULONG_PTR)Entry->Object;
 
     if(!Current || (HandleTable->Flags & EX_HANDLE_TABLE_CLOSING))
     {
@@ -719,7 +724,7 @@
     if(!(Current & EX_HANDLE_ENTRY_LOCKED))
     {
       New = Current | EX_HANDLE_ENTRY_LOCKED;
-      if(InterlockedCompareExchangePointer(&Entry->u1.Object,
+      if(InterlockedCompareExchangePointer(&Entry->Object,
                                            (PVOID)New,
                                            (PVOID)Current) == (PVOID)Current)
       {
@@ -756,13 +761,13 @@
 
   DPRINT("ExUnlockHandleTableEntry HT:0x%p Entry:0x%p\n", HandleTable, Entry);
 
-  Current = (volatile ULONG_PTR)Entry->u1.Object;
+  Current = (volatile ULONG_PTR)Entry->Object;
 
   ASSERT(Current & EX_HANDLE_ENTRY_LOCKED);
 
   New = Current & ~EX_HANDLE_ENTRY_LOCKED;
 
-  (void)InterlockedExchangePointer(&Entry->u1.Object,
+  (void)InterlockedExchangePointer(&Entry->Object,
                                    (PVOID)New);
 
   /* we unlocked the entry, pulse the contention event so threads who're waiting
@@ -784,10 +789,10 @@
   ASSERT(HandleTable);
   ASSERT(Entry);
 
-  /* The highest bit in Entry->u1.Object has to be 1 so we make sure it's a
+  /* The highest bit in Entry->Object has to be 1 so we make sure it's a
      pointer to kmode memory. It will cleared though because it also indicates
      the lock */
-  ASSERT((ULONG_PTR)Entry->u1.Object & EX_HANDLE_ENTRY_LOCKED);
+  ASSERT((ULONG_PTR)Entry->Object & EX_HANDLE_ENTRY_LOCKED);
 
   KeEnterCriticalRegion();
   ExAcquireHandleTableLockExclusive(HandleTable);
@@ -855,7 +860,7 @@
   ASSERT(Entry);
 
   /* This routine requires the entry to be locked */
-  ASSERT((ULONG_PTR)Entry->u1.Object & EX_HANDLE_ENTRY_LOCKED);
+  ASSERT((ULONG_PTR)Entry->Object & EX_HANDLE_ENTRY_LOCKED);
 
   DPRINT("DestroyHandleByEntry HT:0x%p Entry:0x%p\n", HandleTable, Entry);
 
Index: ntoskrnl/ex/power.c
===================================================================
--- ntoskrnl/ex/power.c	(revision 21808)
+++ ntoskrnl/ex/power.c	(working copy)
@@ -15,9 +15,13 @@
 
 /* FUNCTIONS *****************************************************************/
 
-VOID STDCALL
-KeSetTargetProcessorDpc (IN	PKDPC	Dpc,
-			 IN	CCHAR	Number);
+/* ROS Internal. Please deprecate */
+NTHALAPI
+VOID
+NTAPI
+HalReleaseDisplayOwnership(
+    VOID
+);
 
 VOID STDCALL
 KiHaltProcessorDpcRoutine(IN PKDPC Dpc,
Index: ntoskrnl/ex/rundown.c
===================================================================
--- ntoskrnl/ex/rundown.c	(revision 21808)
+++ ntoskrnl/ex/rundown.c	(working copy)
@@ -230,7 +230,7 @@
     if (InterlockedExchangeAddSizeT(&WaitBlock->Count, -1))
     {
         /* We're down to 0 now, so signal the event */
-        KeSetEvent(&WaitBlock->RundownEvent, IO_NO_INCREMENT, FALSE);
+        KeSetEvent(&WaitBlock->WakeEvent, IO_NO_INCREMENT, FALSE);
     }
 }
 
@@ -290,7 +290,7 @@
         (LONG)Count)
     {
         /* We're down to 0 now, so signal the event */
-        KeSetEvent(&WaitBlock->RundownEvent, IO_NO_INCREMENT, FALSE);
+        KeSetEvent(&WaitBlock->WakeEvent, IO_NO_INCREMENT, FALSE);
     }
 }
 
@@ -339,12 +339,12 @@
         if (Count || !Event)
         {
             /* Initialize the event */
-            KeInitializeEvent(&WaitBlock.RundownEvent,
+            KeInitializeEvent(&WaitBlock.WakeEvent,
                               NotificationEvent,
                               FALSE);
 
             /* Set the pointer */
-            Event = &WaitBlock.RundownEvent;
+            Event = &WaitBlock.WakeEvent;
         }
 
         /* Set the count */
Index: ntoskrnl/lpc/close.c
===================================================================
--- ntoskrnl/lpc/close.c	(revision 21808)
+++ ntoskrnl/lpc/close.c	(working copy)
@@ -28,7 +28,11 @@
  * REVISIONS
  */
 VOID STDCALL
-LpcpClosePort (PVOID	ObjectBody, ULONG	HandleCount)
+LpcpClosePort (IN PEPROCESS Process OPTIONAL,
+               IN PVOID ObjectBody,
+               IN ACCESS_MASK GrantedAccess,
+               IN ULONG HandleCount,
+               IN ULONG SystemHandleCount)
 {
   PEPORT Port = (PEPORT)ObjectBody;
   PORT_MESSAGE Message;
Index: ntoskrnl/po/power.c
===================================================================
--- ntoskrnl/po/power.c	(revision 21808)
+++ ntoskrnl/po/power.c	(working copy)
@@ -298,7 +298,7 @@
 VOID
 INIT_FUNCTION
 NTAPI
-PoInit(PLOADER_PARAMETER_BLOCK LoaderBlock,
+PoInit(PROS_LOADER_PARAMETER_BLOCK LoaderBlock,
        BOOLEAN ForceAcpiDisable)
 {
   if (ForceAcpiDisable)
Index: base/services/umpnpmgr/umpnpmgr.c
===================================================================
--- base/services/umpnpmgr/umpnpmgr.c	(revision 21808)
+++ base/services/umpnpmgr/umpnpmgr.c	(working copy)
@@ -298,9 +298,8 @@
 
     PlugPlayData.Relation = Relationship;
 
-    PlugPlayData.RelatedDeviceInstance.Length = 0;
-    PlugPlayData.RelatedDeviceInstance.MaximumLength = Length;
-    PlugPlayData.RelatedDeviceInstance.Buffer = RelatedDeviceId;
+    PlugPlayData.RelatedDeviceInstanceLength = Length;
+    PlugPlayData.RelatedDeviceInstance = RelatedDeviceId;
 
     Status = NtPlugPlayControl(PlugPlayControlGetRelatedDevice,
                                (PVOID)&PlugPlayData,
Index: base/applications/taskmgr/perfdata.c
===================================================================
--- base/applications/taskmgr/perfdata.c	(revision 21808)
+++ base/applications/taskmgr/perfdata.c	(working copy)
@@ -35,7 +35,7 @@
 LARGE_INTEGER                    liOldSystemTime = {{0,0}};
 SYSTEM_PERFORMANCE_INFORMATION    SystemPerfInfo;
 SYSTEM_BASIC_INFORMATION        SystemBasicInfo;
-SYSTEM_CACHE_INFORMATION        SystemCacheInfo;
+SYSTEM_FILECACHE_INFORMATION        SystemCacheInfo;
 SYSTEM_HANDLE_INFORMATION        SystemHandleInfo;
 PSYSTEM_PROCESSOR_PERFORMANCE_INFORMATION SystemProcessorTimeInfo = NULL;
 PSID                             SystemUserSid = NULL;
@@ -95,7 +95,7 @@
     HANDLE                            hProcessToken;
     SYSTEM_PERFORMANCE_INFORMATION    SysPerfInfo;
     SYSTEM_TIMEOFDAY_INFORMATION      SysTimeInfo;
-    SYSTEM_CACHE_INFORMATION        SysCacheInfo;
+    SYSTEM_FILECACHE_INFORMATION        SysCacheInfo;
     LPBYTE                            SysHandleInfoData;
     PSYSTEM_PROCESSOR_PERFORMANCE_INFORMATION SysProcessorTimeInfo;
     double                            CurrentKernelTime;
@@ -170,7 +170,7 @@
     /*
      * Save system cache info
      */
-    memcpy(&SystemCacheInfo, &SysCacheInfo, sizeof(SYSTEM_CACHE_INFORMATION));
+    memcpy(&SystemCacheInfo, &SysCacheInfo, sizeof(SYSTEM_FILECACHE_INFORMATION));
 
     /*
      * Save system processor time info
Index: dll/win32/advapi32/sec/ac.c
===================================================================
--- dll/win32/advapi32/sec/ac.c	(revision 21808)
+++ dll/win32/advapi32/sec/ac.c	(working copy)
@@ -578,8 +578,6 @@
         {
             /* directly copy the array, this works as the size of the EXPLICIT_ACCESS_A
                structure matches the size of the EXPLICIT_ACCESS_W version */
-            ASSERT(sizeof(EXPLICIT_ACCESS_A) == sizeof(EXPLICIT_ACCESS_W));
-
             RtlCopyMemory(ListOfExplicitEntriesW,
                           pListOfExplicitEntries,
                           cCountOfExplicitEntries * sizeof(EXPLICIT_ACCESS_W));
Index: dll/win32/kernel32/file/create.c
===================================================================
--- dll/win32/kernel32/file/create.c	(revision 21808)
+++ dll/win32/kernel32/file/create.c	(working copy)
@@ -14,6 +14,10 @@
 
 /* INCLUDES *****************************************************************/
 
+/* File contains Vista Semantics */
+#undef _WIN32_WINNT
+#define _WIN32_WINNT 0x0600
+
 #include <k32.h>
 
 #define NDEBUG
@@ -399,14 +403,14 @@
 
     switch(RtlDetermineDosPathNameType_U(lpTargetFileName))
     {
-    case INVALID_PATH:
-    case ABSOLUTE_PATH:
-    case RELATIVE_PATH:
+    case RtlPathTypeUnknown:
+    case RtlPathTypeRooted:
+    case RtlPathTypeRelative:
         bRelativePath = TRUE;
         RtlInitUnicodeString(&TargetFileName, lpTargetFileName);
         break;
 
-    case RELATIVE_DRIVE_PATH:
+    case RtlPathTypeDriveRelative:
         {
             LPWSTR FilePart;
             SIZE_T cchTargetFullFileName;
@@ -438,10 +442,10 @@
 
         // fallthrough
 
-    case UNC_PATH:
-    case ABSOLUTE_DRIVE_PATH:
-    case DEVICE_PATH:
-    case UNC_DOT_PATH:
+    case RtlPathTypeUncAbsolute:
+    case RtlPathTypeDriveAbsolute:
+    case RtlPathTypeLocalDevice:
+    case RtlPathTypeRootLocalDevice:
     default:
         if(!RtlDosPathNameToNtPathName_U(lpTargetFileName, &TargetFileName, NULL, NULL))
         {
Index: dll/win32/kernel32/file/file.c
===================================================================
--- dll/win32/kernel32/file/file.c	(revision 21808)
+++ dll/win32/kernel32/file/file.c	(working copy)
@@ -12,6 +12,10 @@
 
 /* INCLUDES *****************************************************************/
 
+/* File contains Vista Semantics */
+#undef _WIN32_WINNT
+#define _WIN32_WINNT 0x0600
+
 #include <k32.h>
 
 #define NDEBUG
Index: dll/win32/kernel32/misc/recovery.c
===================================================================
--- dll/win32/kernel32/misc/recovery.c	(revision 21808)
+++ dll/win32/kernel32/misc/recovery.c	(working copy)
@@ -30,6 +30,10 @@
  *                  10/28/2005 Created stubs (w3)
  */
 
+/* File contains Vista Semantics */
+#undef _WIN32_WINNT
+#define _WIN32_WINNT 0x0600
+
 #include <k32.h>
 
 #define NDEBUG
Index: dll/win32/kernel32/misc/profile.c
===================================================================
--- dll/win32/kernel32/misc/profile.c	(revision 21808)
+++ dll/win32/kernel32/misc/profile.c	(working copy)
@@ -756,7 +756,7 @@
 
     GetWindowsDirectoryW( windirW, MAX_PATH );
 
-    if ((RtlDetermineDosPathNameType_U(filename) == RELATIVE_PATH) &&
+    if ((RtlDetermineDosPathNameType_U(filename) == RtlPathTypeRelative) &&
         !wcschr(filename, '\\') && !wcschr(filename, '/'))
     {
         static const WCHAR wszSeparator[] = {'\\', 0};
Index: dll/win32/kernel32/misc/utils.c
===================================================================
--- dll/win32/kernel32/misc/utils.c	(revision 21808)
+++ dll/win32/kernel32/misc/utils.c	(working copy)
@@ -9,6 +9,7 @@
 /* INCLUDES ****************************************************************/
 
 #include <k32.h>
+#include "i386/ketypes.h"
 
 #define NDEBUG
 #include "../include/debug.h"
Index: dll/win32/kernel32/misc/console.c
===================================================================
--- dll/win32/kernel32/misc/console.c	(revision 21808)
+++ dll/win32/kernel32/misc/console.c	(working copy)
@@ -14,6 +14,10 @@
 
 /* INCLUDES ******************************************************************/
 
+/* File contains Vista Semantics */
+#undef _WIN32_WINNT
+#define _WIN32_WINNT 0x0600
+
 #include <k32.h>
 
 #define NDEBUG
Index: dll/win32/kernel32/misc/ldr.c
===================================================================
--- dll/win32/kernel32/misc/ldr.c	(revision 21808)
+++ dll/win32/kernel32/misc/ldr.c	(working copy)
@@ -196,14 +196,14 @@
     {
         /* Call the API Properly */
         Status = LdrLoadDll(SearchPath,
-                            (ULONG)&DllCharacteristics, // Silence compiler
+                            &DllCharacteristics,
                             &DllName,
                             (PVOID*)&hInst);
     }
     else
     {
         /* Call the ROS API. NOTE: Don't fix this, I have a patch to merge later. */
-        Status = LdrLoadDll(SearchPath, dwFlags, &DllName, (PVOID*)&hInst);
+        Status = LdrLoadDll(SearchPath, &dwFlags, &DllName, (PVOID*)&hInst);
     }
 	RtlFreeHeap(RtlGetProcessHeap(), 0, SearchPath);
 	if ( !NT_SUCCESS(Status))
@@ -305,7 +305,7 @@
 
 	while (Entry != ModuleListHead)
 	{
-		Module = CONTAINING_RECORD(Entry, LDR_DATA_TABLE_ENTRY, InLoadOrderModuleList);
+		Module = CONTAINING_RECORD(Entry, LDR_DATA_TABLE_ENTRY, InLoadOrderLinks);
 		if (Module->DllBase == (PVOID)hModule)
 		{
 			if (nSize * sizeof(WCHAR) < Module->FullDllName.Length)
@@ -372,7 +372,7 @@
 	Entry = ModuleListHead->Flink;
 	while (Entry != ModuleListHead)
 	{
-		Module = CONTAINING_RECORD(Entry, LDR_DATA_TABLE_ENTRY, InLoadOrderModuleList);
+		Module = CONTAINING_RECORD(Entry, LDR_DATA_TABLE_ENTRY, InLoadOrderLinks);
 
 		if (Module->DllBase == (PVOID)hModule)
 		{
Index: dll/win32/kernel32/misc/toolhelp.c
===================================================================
--- dll/win32/kernel32/misc/toolhelp.c	(revision 21808)
+++ dll/win32/kernel32/misc/toolhelp.c	(working copy)
@@ -92,8 +92,8 @@
 /* INTERNAL FUNCTIONS *********************************************************/
 
 static VOID
-TH32FreeAllocatedResources(PRTL_DEBUG_BUFFER HeapDebug,
-                           PRTL_DEBUG_BUFFER ModuleDebug,
+TH32FreeAllocatedResources(PRTL_DEBUG_INFORMATION HeapDebug,
+                           PRTL_DEBUG_INFORMATION ModuleDebug,
                            PVOID ProcThrdInfo,
                            SIZE_T ProcThrdInfoSize)
 {
@@ -118,8 +118,8 @@
 static NTSTATUS
 TH32CreateSnapshot(DWORD dwFlags,
                    DWORD th32ProcessID,
-                   PRTL_DEBUG_BUFFER *HeapDebug,
-                   PRTL_DEBUG_BUFFER *ModuleDebug,
+                   PRTL_DEBUG_INFORMATION *HeapDebug,
+                   PRTL_DEBUG_INFORMATION *ModuleDebug,
                    PVOID *ProcThrdInfo,
                    SIZE_T *ProcThrdInfoSize)
 {
@@ -221,8 +221,8 @@
 static NTSTATUS
 TH32CreateSnapshotSectionInitialize(DWORD dwFlags,
                                     DWORD th32ProcessID,
-                                    PRTL_DEBUG_BUFFER HeapDebug,
-                                    PRTL_DEBUG_BUFFER ModuleDebug,
+                                    PRTL_DEBUG_INFORMATION HeapDebug,
+                                    PRTL_DEBUG_INFORMATION ModuleDebug,
                                     PVOID ProcThrdInfo,
                                     HANDLE *SectionHandle)
 {
@@ -248,8 +248,8 @@
    */
   if(dwFlags & TH32CS_SNAPHEAPLIST)
   {
-    hi = (PRTL_PROCESS_HEAPS)HeapDebug->HeapInformation;
-    nHeaps = hi->HeapCount;
+    hi = (PRTL_PROCESS_HEAPS)HeapDebug->Heaps;
+    nHeaps = hi->NumberOfHeaps;
     RequiredSnapshotSize += nHeaps * sizeof(HEAPLIST32);
   }
 
@@ -258,8 +258,8 @@
    */
   if(dwFlags & TH32CS_SNAPMODULE)
   {
-    mi = (PRTL_PROCESS_MODULES)ModuleDebug->ModuleInformation;
-    nModules = mi->ModuleCount;
+    mi = (PRTL_PROCESS_MODULES)ModuleDebug->Modules;
+    nModules = mi->NumberOfModules;
     RequiredSnapshotSize += nModules * sizeof(MODULEENTRY32W);
   }
 
@@ -350,13 +350,13 @@
     {
       HeapListEntry->dwSize = sizeof(HEAPLIST32);
       HeapListEntry->th32ProcessID = th32ProcessID;
-      HeapListEntry->th32HeapID = (ULONG_PTR)hi->HeapEntry[i].Base;
-      HeapListEntry->dwFlags = hi->HeapEntry[i].Flags;
+      HeapListEntry->th32HeapID = (ULONG_PTR)hi->Heaps[i].BaseAddress;
+      HeapListEntry->dwFlags = hi->Heaps[i].Flags;
 
       HeapListEntry++;
     }
 
-    DataOffset += hi->HeapCount * sizeof(HEAPLIST32);
+    DataOffset += hi->NumberOfHeaps * sizeof(HEAPLIST32);
   }
 
   /* initialize the module list */
@@ -370,22 +370,22 @@
       ModuleListEntry->dwSize = sizeof(MODULEENTRY32W);
       ModuleListEntry->th32ModuleID = 1; /* no longer used, always set to one! */
       ModuleListEntry->th32ProcessID = th32ProcessID;
-      ModuleListEntry->GlblcntUsage = mi->ModuleEntry[i].LoadCount;
-      ModuleListEntry->ProccntUsage = mi->ModuleEntry[i].LoadCount;
-      ModuleListEntry->modBaseAddr = (BYTE*)mi->ModuleEntry[i].Base;
-      ModuleListEntry->modBaseSize = mi->ModuleEntry[i].Size;
-      ModuleListEntry->hModule = (HMODULE)mi->ModuleEntry[i].Base;
+      ModuleListEntry->GlblcntUsage = mi->Modules[i].LoadCount;
+      ModuleListEntry->ProccntUsage = mi->Modules[i].LoadCount;
+      ModuleListEntry->modBaseAddr = (BYTE*)mi->Modules[i].ImageBase;
+      ModuleListEntry->modBaseSize = mi->Modules[i].ImageSize;
+      ModuleListEntry->hModule = (HMODULE)mi->Modules[i].ImageBase;
 
       MultiByteToWideChar(CP_ACP,
                           0,
-                          &mi->ModuleEntry[i].ImageName[mi->ModuleEntry[i].ModuleNameOffset],
+                          &mi->Modules[i].FullPathName[mi->Modules[i].OffsetToFileName],
                           -1,
                           ModuleListEntry->szModule,
                           sizeof(ModuleListEntry->szModule) / sizeof(ModuleListEntry->szModule[0]));
 
       MultiByteToWideChar(CP_ACP,
                           0,
-                          mi->ModuleEntry[i].ImageName,
+                          mi->Modules[i].FullPathName,
                           -1,
                           ModuleListEntry->szExePath,
                           sizeof(ModuleListEntry->szExePath) / sizeof(ModuleListEntry->szExePath[0]));
@@ -393,7 +393,7 @@
       ModuleListEntry++;
     }
 
-    DataOffset += mi->ModuleCount * sizeof(MODULEENTRY32W);
+    DataOffset += mi->NumberOfModules * sizeof(MODULEENTRY32W);
   }
 
   /* initialize the process list */
@@ -1113,7 +1113,7 @@
 STDCALL
 CreateToolhelp32Snapshot(DWORD dwFlags, DWORD th32ProcessID)
 {
-  PRTL_DEBUG_BUFFER HeapDebug, ModuleDebug;
+  PRTL_DEBUG_INFORMATION HeapDebug, ModuleDebug;
   PVOID ProcThrdInfo;
   SIZE_T ProcThrdInfoSize;
   NTSTATUS Status;
Index: dll/win32/kernel32/kernel32.rbuild
===================================================================
--- dll/win32/kernel32/kernel32.rbuild	(revision 21808)
+++ dll/win32/kernel32/kernel32.rbuild	(working copy)
@@ -5,11 +5,10 @@
 	<define name="_DISABLE_TIDENTS" />
 	<define name="_SEH_NO_NATIVE_NLG" />
 	<define name="__USE_W32API" />
-	<define name="_WIN32_WINNT">0x0600</define>
+	<define name="_WIN32_WINNT">0x0502</define>
 	<define name="__NO_CTYPE_INLINES" />
-	<define name="WINVER">0x0600</define>
+	<define name="WINVER">0x502</define>
 	<pch>k32.h</pch>
-	<compilationunit name="unit.c">
 	<directory name="debug">
 		<file>break.c</file>
 		<file>debugger.c</file>
@@ -104,7 +103,6 @@
 		<file>thread.c</file>
 		<file>tls.c</file>
 	</directory>
-	</compilationunit>
 	<directory name="misc">
 		<file>lcformat.c</file>
 		<file>profile.c</file>
Index: dll/win32/kernel32/thread/tls.c
===================================================================
--- dll/win32/kernel32/thread/tls.c	(revision 21808)
+++ dll/win32/kernel32/thread/tls.c	(working copy)
@@ -17,8 +17,6 @@
 #define NDEBUG
 #include "../include/debug.h"
 
-#define TLS_EXPANSION_SLOTS (8 * sizeof(((PPEB)NULL)->TlsExpansionBitmapBits))
-
 /* FUNCTIONS *****************************************************************/
 
 /*
Index: dll/win32/kernel32/process/create.c
===================================================================
--- dll/win32/kernel32/process/create.c	(revision 21808)
+++ dll/win32/kernel32/process/create.c	(working copy)
@@ -883,7 +883,7 @@
             PathType = RtlDetermineDosPathNameType_U(lpApplicationName);
                     
             /* If it's not relative, try to get the error */
-            if (PathType != RELATIVE_PATH)
+            if (PathType != RtlPathTypeRelative)
             {
                 /* This should fail, and give us a detailed LastError */
                 hFile = CreateFileW(lpApplicationName,
Index: dll/win32/psapi/psapi.c
===================================================================
--- dll/win32/psapi/psapi.c	(revision 21808)
+++ dll/win32/psapi/psapi.c	(working copy)
@@ -42,7 +42,7 @@
 } ENUM_DEVICE_DRIVERS_CONTEXT, *PENUM_DEVICE_DRIVERS_CONTEXT;
 
 NTSTATUS STDCALL
-EnumDeviceDriversCallback(IN PSYSTEM_MODULE_INFORMATION_ENTRY CurrentModule,
+EnumDeviceDriversCallback(IN PRTL_PROCESS_MODULE_INFORMATION CurrentModule,
                           IN OUT PVOID CallbackContext)
 {
   PENUM_DEVICE_DRIVERS_CONTEXT Context = (PENUM_DEVICE_DRIVERS_CONTEXT)CallbackContext;
@@ -54,7 +54,7 @@
   }
 
   /* return current module */
-  *Context->lpImageBase = CurrentModule->Base;
+  *Context->lpImageBase = CurrentModule->ImageBase;
 
   /* go to next array slot */
   Context->lpImageBase++;
@@ -141,22 +141,22 @@
 } GET_DEVICE_DRIVER_NAME_CONTEXT, *PGET_DEVICE_DRIVER_NAME_CONTEXT;
 
 NTSTATUS STDCALL
-GetDeviceDriverNameCallback(IN PSYSTEM_MODULE_INFORMATION_ENTRY CurrentModule,
+GetDeviceDriverNameCallback(IN PRTL_PROCESS_MODULE_INFORMATION CurrentModule,
                             IN OUT PVOID CallbackContext)
 {
   PGET_DEVICE_DRIVER_NAME_CONTEXT Context = (PGET_DEVICE_DRIVER_NAME_CONTEXT)CallbackContext;
 
   /* module found */
-  if(Context->ImageBase == CurrentModule->Base)
+  if(Context->ImageBase == CurrentModule->ImageBase)
   {
     PCHAR pcModuleName;
     ULONG l;
 
     /* get the full name or just the filename part */
     if(Context->bFullName)
-      pcModuleName = &CurrentModule->ImageName[0];
+      pcModuleName = &CurrentModule->FullPathName[0];
     else
-      pcModuleName = &CurrentModule->ImageName[CurrentModule->PathLength];
+      pcModuleName = &CurrentModule->FullPathName[CurrentModule->OffsetToFileName];
 
     /* get the length of the name */
     l = strlen(pcModuleName);
